'use strict';

var babel = require('@babel/core');

function _interopNamespaceDefault(e) {
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: function () { return e[k]; }
        });
      }
    });
  }
  n.default = e;
  return Object.freeze(n);
}

var babel__namespace = /*#__PURE__*/_interopNamespaceDefault(babel);

/*******************************************************************************
 *
 *    Copyright (c) 2022 - 2023.
 *    Haixing Hu, Qubit Co. Ltd.
 *
 *    All rights reserved.
 *
 ******************************************************************************/

const DEFAULT_FILTER = /\.(jsx?|vue)$/;

const babelPlugin = (options = {}) => ({
  name: 'vite-plugin-babel',
  transform: (src, id) => {
    const config = options.config || {};
    const filter = options.filter || DEFAULT_FILTER;
    if (filter.test(id)) {
      config.filename = id;
      return babel__namespace.transform(src, config);
    }
  },
});

module.exports = babelPlugin;
